varying vec3 V_eye;
varying vec3 L_eye;
varying vec3 N_eye;
varying float x;

void main(void)
{
	//-------------------------------------------------------------------------
	// Coloring	
	//-------------------------------------------------------------------------

 	vec4 color = vec4(0.3, 0.2, 0.6, 1.0);
	if (fract(3.0*x)>0.8) color = vec4(1.0, 0.0, 0.3, 1.0);

	//-------------------------------------------------------------------------
	// Lighting	
	//-------------------------------------------------------------------------

	vec3 V = normalize(V_eye);
	vec3 L = normalize(L_eye);
	vec3 N = normalize(N_eye);

	float NdotL = dot(L, N);

	// Ambient light
	gl_FragColor = color*0.2;

	if (NdotL>0.0)
	{
		// Diffuse light
		gl_FragColor += color*NdotL;

		// Sharp specular light
		vec3 R = (2.0*NdotL)*N - L;
		float specular = pow(max(0.0, dot(R, V)), 64.0);
		specular = smoothstep(0.5, 0.75, specular);
		gl_FragColor += specular;
	}
}
